#include <hmg.ch>
#include <GraphPlus.ch>

Function Main
   private oGridGraph, oBarGraph, oHMGColumn, oHMGPoints, oHMGLine, oHMGPie, oHMGBar, oHMGFunnel, oStackedColumn, oStackedBar
   define window chart at 0, 0 width 890 height 800 title 'GraphPlus Demo' main
      define tab tab1 at 10, 10 width 860 height 700
         define page 'Column'
            define image hmgcolumn
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Points'
            define image hmgpoints
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Line'
            define image hmgline
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Pie'
            define image hmgpie
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Bars'
            define image barchart
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Bar'
            define image hmgbar
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Funnel'
            define image hmgfunnel
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Grid Data'
            define image gridchart
               row 30
               col 30
               width 800
               height 400
            end image
            define grid data
               row 440
               col 30
               width 400
               height 180
               headers { 'Period', 'Sales', 'Profit' }
               widths { 100, 120, 120 }
               justify { 0, 1, 1 }
               items { { 'January', '15000', '2500' }, { 'February', '14000', '2800' },;
                        { 'March', '10000', '-2000' },;               
                        { 'April', '16000', '3500' },;
                        { 'May', '15800', '3000' },;
                        { 'June', '16400', '4000' },;
                        { 'July', '15300', '2800' }}
               value 1                        
            end grid  
         end page            
         define page 'Stacked Column'
            define image stackedcolumn
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Stacked Bar'
            define image stackedbar
               row 30
               col 30
               width 800
               height 600
            end image
         end page
      end tab
      define button savefiles
         row 720
         col 10
         width 80
         caption 'Save All'
         action saveallfiles()
      end button   
      define button switch
         row 720
         col 110
         width 180
         caption 'Switch Rows and Columns'
         action switchrows()
      end button   
   end window
   drawcharts()
   chart.center
   chart.activate
Return

function drawcharts
   
   // hmgcolumn
   oHMGColumn := GraphPlus():New()
   with object oHMGColumn
      :GraphData := { { 14280,  20420,  12870,  25347,   7640 },;
                           {  8350,  10315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :ShowLegends := .t.
      :LegendPos := LEGEND_ON_RIGHT
      :Width := 800
      :Height := 600
      :Title := 'Sample Graph'
      :ShowLabels := .t.
      :Picture := '99,999.99'  
      :BarGapRatio := -0.4     
      :Draw()
      chart.hmgcolumn.hBitmap := :Bitmap()
   endwith
   // hmgpoints
   oHMGPoints := GraphPlus():New()
   with object oHMGPoints
      :GraphData := { { 14280,  20420,  12870,  25347,   7640 },;
                           {  8350,  10315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :ShowLegends := .t.
      :LegendPos := 0
      :Width := 800
      :Height := 600
      :Title := 'Sample Graph'
      :Picture := '99,999.99' 
      :ShowLabels := .t.
      :GraphType := GT_POINTS      
      :Draw()
      chart.hmgpoints.hBitmap := :Bitmap()
   endwith
   // hmgline
   oHMGLine := GraphPlus():New()
   with object oHMGLine
      :GraphData := { { 14280,  20420,  12870,  25347,   7640 },;
                           {  8350,  10315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :ShowLegends := .t.
      :LegendPos := 0
      :Width := 800
      :Height := 600
      :Title := 'Sample Graph'
      :Picture := '99,999.99' 
      :ShowLabels := .t.
      :GraphType := GT_LINE      
      :Draw()
      chart.hmgline.hBitmap := :Bitmap()
   endwith

   // pie
   oHMGPie := GraphPlus():New()
   with object oHMGPie
      :GraphData := { 13876405, 13404512, 3397445, 2697803, 2245456, 2166422, 2128265, 1860504, 1314459, 1257990 }
      :Legends   := { "China", "India", "United States of America", "Indonesia", "Brazil", "Pakistan", "Nigeria", "Bangladesh", "Russia", "Mexico" }
      :ShowLegends := .t.
      :LegendPos := 0
      :Width := 800
      :Height := 600
      :Title := 'Population Top 10 Countries'
      :ShowLabels := .t.
      :GraphType := GT_PIE      
      :Draw()
      chart.hmgpie.hBitmap := :Bitmap()
   endwith

   //bars   
   oBarGraph := GraphPlus():new()
   with object oBarGraph
      :GraphData := { { 13876405, 13404512, 3397445, 2697803, 2245456, 2166422, 2128265, 1860504, 1314459, 1257990 },;
      { 16642318, 3049704, 22675271, 1158783, 1491772, 296000, 514049, 352908, 1710734, 1192480 } }
      :Categories := { "China", "India", "United States of America", "Indonesia", "Brazil", "Pakistan", "Nigeria", "Bangladesh", "Russia", "Mexico" }
      :Legends := { "Population in Hundreds", "GDP in Million $" }
      :ShowLegends := .t.
      :Width := 800
      :Height := 600
      :Title := 'World Population - Top 10'
      :ShowLabels := .t.
      :BarGapRatio := 0
      :BarGapWidthRatio := 0.1      
      :GraphType := GT_BAR
      :Draw()
      chart.barchart.hBitmap := :Bitmap()
   endwith
   
   // hmgbar
   oHMGBar := GraphPlus():New()
   with object oHMGBar
      :GraphData := { 1387640576, 1340451200, 339744544, 269780352, 224545616, 216642256, 212826576 , 186050400, 131445920, 125799016 }
      :Categories := { "China", "India", "United States of America", "Indonesia", "Brazil", "Pakistan", "Nigeria", "Bangladesh", "Russia", "Mexico" }
      :Width := 800
      :Height := 600
      :Title := 'World Population - Top 10'
      :ShowLabels := .t.
      :BarGapRatio := 0  
      :BarGapWidthRatio := 0.1      
      :LegendFont := array font 'Arial' size 10
      :GraphType := GT_BAR
      :Draw()
      chart.hmgbar.hBitmap := :Bitmap()
   endwith
   
   // funnel
   oHMGFunnel := GraphPlus():New()
   with object oHMGFunnel
      :GraphData := { 8000, 6000, 4500, 2000, 1200, 900 }
      :Categories := { "Awareness", "Interest", "Consideration", "Intent", "Evaluation", "Purchases" }
      :Width := 800
      :Height := 600
      :Title := 'Sales Funnel'
      :BarGapRatio := 0  
      :BarGapWidthRatio := 0.1      
      :GraphType := GT_FUNNEL
      :LegendFont := create array font 'Arial' size 14 Bold .t.
      :TitleFont := create array font 'Arial' size 16 Bold .t.
      :Draw()
      chart.hmgfunnel.hBitmap := :Bitmap()
   endwith

   // grid data
   oGridGraph := GraphPlus():new()
   with object oGridGraph
      :GridData( 'chart', 'data' )
      :Width := 800
      :Height := 400
      :ShowLegends := .t.
      :LegendPos := 0
      :SwitchRowstoColumns()
      :draw()
      chart.gridchart.hBitmap := :Bitmap()
   endwith   

   // stacked column
   oStackedColumn := GraphPlus():New()
   with object oStackedColumn
      :GraphData := { { 14280,  -20420,  12870,  25347,   7640 },;
                           {  8350,  20315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :ShowLegends := .t.
      :LegendPos := LEGEND_ON_RIGHT
      :Width := 800
      :Height := 600
      :Title := 'Sample Graph'
      :ShowLabels := .t.
      :Picture := '99,999'  
      :BarGapRatio := -0.4     
      :GraphType := GT_STACKEDCOLUMN
      :Draw()
      chart.stackedcolumn.hBitmap := :Bitmap()
   endwith

   // stacked bar
   oStackedBar := GraphPlus():New()
   with object oStackedBar
      :GraphData := { { 14280,  -20420,  12870,  25347,   7640 },;
                           {  8350,  20315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :ShowLegends := .t.
      :LegendPos := LEGEND_ON_BOTTOM
      :Width := 800
      :Height := 600
      :Title := 'Sample Graph'
      :ShowLabels := .t.
      :Picture := '99,999'  
      :BarGapRatio := -0.4     
      :GraphType := GT_STACKEDBAR
      :Draw()
      chart.stackedbar.hBitmap := :Bitmap()
   endwith
   
return nil   

function switchrows
   local nTabNo := chart.tab1.value
   local oObj := nil
   local cControl := ''
   do case 
   case nTabNo == 1 // column
      oObj := oHMGColumn
      cControl := 'hmgcolumn'
   case nTabNo == 2 // points
      oObj := oHMGPoints
      cControl := 'hmgpoints'
   case nTabNo == 3 // Line
      oObj := oHMGLine
      cControl := 'hmgline'
   case nTabNo == 5 // bars
      oObj := oBarGraph
      cControl := 'barchart'
   case nTabNo == 6 // Bar
      oObj := oHMGBar
      cControl := 'hmgbar'
   case nTabNo == 8 // Grid Data
      oObj := oGridGraph
      cControl := 'gridchart'
   case nTabNo == 9 // StackedBar
      oObj := oStackedColumn
      cControl := 'stackedcolumn'
   case nTabNo == 10 // StackedBar
      oObj := oStackedBar
      cControl := 'stackedbar'
   endcase
   if oObj <> nil
      with object oObj
         :SwitchRowstoColumns()
         :Draw()
         setproperty( 'Chart', cControl, 'HBITMAP', :Bitmap() )
      endwith
   endif   
return nil   

function saveallfiles
   oHMGColumn:save('graphplus01.png')
   oHMGPoints:save('graphplus02.png')
   oHMGLine:save('graphplus03.png')
   oHMGPie:save('graphplus04.png')
   oBarGraph:save('graphplus05.png')
   oHMGBar:save('graphplus06.png')
   oHMGFunnel:save('graphplus07.png')
   oGridGraph:save('graphplus08.png')
   oStackedColumn:save('graphplus09.png')
   oStackedBar:save('graphplus10.png')
   
return nil